﻿using BepInEx;
using BepInEx.Configuration;
using HarmonyLib;
using RoR2.CameraModes;
using System.IO;
using System.Reflection;
using System.Security.Permissions;
using Stage = RoR2.Stage;
using Zoom = EntityStates.Railgunner.Scope.BaseScopeState;

[assembly: AssemblyVersion(Local.Scope.Sensitivity.Plugin.versionNumber)]
[assembly: SecurityPermission(SecurityAction.RequestMinimum, SkipVerification = true)]
		// Allow private member access via publicized assemblies.

namespace Local.Scope.Sensitivity
{
	[BepInPlugin("local.scope.sensitivity", "ScopeSensitivity", versionNumber)]
	public class Plugin : BaseUnityPlugin
	{
		public const string versionNumber = "0.1.1";

		private static float sensitivity, multiplier = none;
		private const float none = 1.0f;

		public void Awake()
		{
			Load(Config);
			new FileSystemWatcher {
					Path = Path.GetDirectoryName(Config.ConfigFilePath),
					Filter = Path.GetFileName(Config.ConfigFilePath),
					InternalBufferSize = 0, EnableRaisingEvents = true
				}.Changed += ( _, __ ) => Load(Config);

			Stage.onStageStartGlobal += _ => multiplier = none;
			Harmony.CreateAndPatchAll(typeof(Plugin));
		}

		private static void Load(ConfigFile configuration)
		{
			try { configuration.Reload(); }
			catch ( FileNotFoundException ) { configuration.Clear(); }

			const float percent = 100;
			sensitivity = configuration.Bind(
					section: "General",
					key: "Scope Sensitivity",
					defaultValue: percent * 2 / 3,
					new ConfigDescription(
						"Adjust this percentage to change the mouse sensitivity for "
							+ "Railgunner's secondary skill. Set the value to 100% to "
							+ "disable - changes will be applied immediately on save.",
						new AcceptableValueRange<float>(0, percent + percent))
				).Value / percent;
		}

		[HarmonyPatch(typeof(Zoom), nameof(Zoom.OnEnter))]
		[HarmonyPostfix]
		private static void ApplySensitivity(Zoom __instance)
		{
			if ( __instance.isAuthority )
				multiplier = sensitivity;
		}

		[HarmonyPatch(typeof(Zoom), nameof(Zoom.OnExit))]
		[HarmonyPrefix]
		private static void RevertMultiplier(Zoom __instance)
		{
			if ( __instance.isAuthority )
				multiplier = none;
		}

		[HarmonyPatch(typeof(CameraModeBase), nameof(CameraModeBase.CollectLookInput))]
		[HarmonyPostfix]
		private static void AdjustInput(ref CameraModeBase.CollectLookInputResult result)
				=> result.lookInput *= multiplier;
	}
}
